// SettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "SettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CVobBlankerApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg dialog


CSettingsDlg::CSettingsDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSettingsDlg)
	m_bCheckBlankNoB = FALSE;
	m_bCheckElapsed = FALSE;
	m_bCheckNextMenu = FALSE;
	m_bCheckNextTitle = FALSE;
	m_bCheckPrevMenu = FALSE;
	m_bCheckPrevTitle = FALSE;
	m_bCheckAttrMenu = TRUE;
	m_bCheckAttrTitle = TRUE;
	//}}AFX_DATA_INIT
}


void CSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsDlg)
	DDX_Control(pDX, IDC_COMBOSTILL, m_ComboStill);
	DDX_Control(pDX, IDC_COMBOMINSTILL, m_ComboMinStill);
	DDX_Control(pDX, IDC_COMBOMAXSTILL, m_ComboMaxStill);
	DDX_Check(pDX, IDC_CHECKBLANKNOBUTTONS, m_bCheckBlankNoB);
	DDX_Check(pDX, IDC_CHECKELAPSED, m_bCheckElapsed);
	DDX_Check(pDX, IDC_CHECKNEXTMENU, m_bCheckNextMenu);
	DDX_Check(pDX, IDC_CHECKNEXTTITLE, m_bCheckNextTitle);
	DDX_Check(pDX, IDC_CHECKPREVMENU, m_bCheckPrevMenu);
	DDX_Check(pDX, IDC_CHECKPREVTITLE, m_bCheckPrevTitle);
	DDX_Check(pDX, IDC_CHECKATTRMENU, m_bCheckAttrMenu);
	DDX_Check(pDX, IDC_CHECKATTRTITLE, m_bCheckAttrTitle);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CSettingsDlg)
	ON_BN_CLICKED(IDDEFAULT, OnDefault)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg message handlers

BOOL CSettingsDlg::OnInitDialog()
{

	int i;
	CString csAux;

	CDialog::OnInitDialog();

	m_bCheckBlankNoB=	theApp.m_bCheckBlankNoB;
	m_bCheckNextMenu=	theApp.m_bCheckNextMenu;
	m_bCheckNextTitle=	theApp.m_bCheckNextTitle;
	m_bCheckPrevMenu=	theApp.m_bCheckPrevMenu;
	m_bCheckPrevTitle=	theApp.m_bCheckPrevTitle;
	m_bCheckAttrMenu=	theApp.m_bCheckAttrMenu;
	m_bCheckAttrTitle=	theApp.m_bCheckAttrTitle;
	m_bCheckElapsed=	theApp.m_bCheckElapsed;

	m_ComboStill.ResetContent();
	m_ComboStill.AddString("First");
	m_ComboStill.AddString("Middle");
	m_ComboStill.AddString("Last");
	m_ComboStill.AddString("Auto");
	m_ComboStill.SetCurSel(theApp.m_iIFrameMode);

	m_ComboMinStill.ResetContent();
	for (i=0;i<30;i++)
	{
		csAux.Format(_T("%d"),i+1);
		m_ComboMinStill.AddString(csAux);
	}
	m_ComboMinStill.SetCurSel(theApp.m_iIMinStill);

	m_ComboMaxStill.ResetContent();
	for (i=0;i<20;i++)
	{
		csAux.Format(_T("%d"),i+1);
		m_ComboMaxStill.AddString(csAux);
	}
	m_ComboMaxStill.SetCurSel(theApp.m_iIMaxStill);

	UpdateData(FALSE);

 //  ToolTips
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Apply changes and close" );
	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Cancel changes and close" );
	m_wndToolTip.AddTool(GetDlgItem(IDDEFAULT), "Reset to default" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_COMBOSTILL), "Selects I-Frame selection mode. Auto means the largest one" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_COMBOMINSTILL), "Selects Min still time in buttons cells when motion2still w/o audio" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_COMBOMAXSTILL), "Selects Max still time in no-buttons cells when motion2still w/o audio" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKNEXTMENU), "Points Next PGCN to the same PGC if pointer is null in no-buttons PGCs" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKNEXTTITLE), "Points Next PGCN to the same PGC if pointer is null" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKPREVMENU), "Points Prev PGCN to the same PGC if pointer is null" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKPREVTITLE), "Points Prev PGCN to the same PGC if pointer is null" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKATTRMENU),  "Clear audio/subs stream status when blanking PGCs" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKATTRTITLE), "Clear audio/subs stream status when blanking PGCs" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKBLANKNOBUTTONS), "Blank Cells without buttons when reducing to still");
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKELAPSED), "Fix elapsed time in Nav packs in Replaced Cells" );

	return TRUE;  // return TRUE  unless you set the focus to a control

}

void CSettingsDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CSettingsDlg::OnOK() 
{
	// TODO: Add extra validation here

	UpdateData(TRUE);

	theApp.m_bCheckBlankNoB=	m_bCheckBlankNoB;
	theApp.m_bCheckNextMenu=	m_bCheckNextMenu;
	theApp.m_bCheckNextTitle=	m_bCheckNextTitle;
	theApp.m_bCheckPrevMenu=	m_bCheckPrevMenu;
	theApp.m_bCheckPrevTitle=	m_bCheckPrevTitle;
	theApp.m_bCheckAttrMenu=	m_bCheckAttrMenu;
	theApp.m_bCheckAttrTitle=	m_bCheckAttrTitle;
	theApp.m_bCheckElapsed=		m_bCheckElapsed;

	theApp.m_iIMaxStill=m_ComboMaxStill.GetCurSel();
	theApp.m_iIMinStill=m_ComboMinStill.GetCurSel();
	theApp.m_iIFrameMode=m_ComboStill.GetCurSel();

	CDialog::OnOK();
}

void CSettingsDlg::OnDefault() 
{
	// TODO: Add your control notification handler code here
	m_bCheckBlankNoB=	FALSE;
	m_bCheckNextMenu=	FALSE;
	m_bCheckNextTitle=	FALSE;
	m_bCheckPrevMenu=	FALSE;
	m_bCheckPrevTitle=	FALSE;
	m_bCheckAttrMenu=	TRUE;
	m_bCheckAttrTitle=	TRUE;
	m_bCheckElapsed=	FALSE;
		
	m_ComboStill.SetCurSel(3);
	m_ComboMinStill.SetCurSel(9);
	m_ComboMaxStill.SetCurSel(4);

	UpdateData(FALSE);
}
