// VobBlanker.h : main header file for the VOBBLANKER application
//

#if !defined(AFX_VOBBLANKER_H__D9C5F094_96B1_4541_8EB0_320F4C91A546__INCLUDED_)
#define AFX_VOBBLANKER_H__D9C5F094_96B1_4541_8EB0_320F4C91A546__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#include <afxtempl.h>

#define VB_VERSION  "1.6.0.5"

#define MAXPACKSPERVOBU 800
#define MAXVOBUSECSLENGTH 8
#define MAXLOOKFORAUDIO 1000
#define MAXLOOKFORAUDIOINMENUS 10000
#define MAXLOOKFORAUDIOREPLACING 10000

#define KEEP		0
#define BLANK		1
#define REPLACE		2
#define STRIP		3
#define CUT			4
#define CELLBASED	5
#define SKIP		6
#define PROCESS		7
#define REUSE		8
#define ZERO		9
#define DELPBK		10
#define STILLA		11
#define STILLNA		12

// Used in Audio dialog
#define ATTRIB		31
#define AUDINFO     32

//Logs
#define LOGNAV			1
#define LOGTMAPTI		1

// Update Module
#define MODUPDATEPACK	10
#define MODUPDATE		1000

// MaxIFOlength 512 KByte
//#define MAXLENGTH  512*1024
//#define MAX_MPGC 1000
//#define MAX_PGC  250
#define MAX_VTS  100
#define MAXLENGTH  10240*1024   //Absolute maximum size of an IFO: 10MB
#define MAX_NEWIFOSECTORS  32   //Free space for IFO growing.
#define MAX_MPGC 32768
#define MAX_PGC  32768
//#define MAX_VTS  35

#define MAX_MLUS 25

#define PAL 1
#define NTSC 0

// Domains
#define TITLES 0
#define MENUS 1

typedef unsigned char uchar;
typedef unsigned long ulong;
typedef unsigned __int64 uint64;


typedef struct NAVINFO
{
    __int64 LBA,LastLBA;
    int VID,CID;
	DWORD dwDuration;
	int frames,seconds;
	int iPTS0,iPTS1;
	bool hasvideo;
} NAVINFO;

typedef struct AUDIOINFO
{
    __int64 LBA;
    int VID,CID;
//	uchar streamID; 
	int iPTS;
} AUDIOINFO;

typedef struct SUBSINFO
{
    __int64 LBA;
    int VID,CID;
//	uchar streamID; 
	int iPTS;
} SUBSINFO;

typedef struct CELL_LIST
{
    int VID,CID;
    __int64 i64FirstLBAFirstVOBU, i64FirstLBALastVOBU, i64LastLBALastVOBU;
	DWORD dwDuration;
	bool bFixPointers; 
	int nNavs;
} CELL_LIST;

typedef struct MENU_CELL_LIST
{
    int VID,CID;
//    __int64 i64FirstLBAFirstVOBU, i64FirstLBALastVOBU, i64LastLBALastVOBU;
//	DWORD dwDuration;
	bool bAlready;
	__int64 i64size;
	__int64 i64IniCell,i64PreButtons,i64IniButtons,i64EndButtons,i64MidButtons,i64MaxButtons;
	__int64 i64IniIFSize,i64EndIFSize,i64MidIFSize,i64MaxIFSize;
	int nButtons,nVOBUS,iIniVOBU;
	int nPreSubs, nPostSubs;
//	bool bFixPointers; 
//	int nNavs;
} MENU_CELL_LIST;

typedef struct CUTINFO
{
    int iIniCell,iIniLba;
    int iEndCell,iEndLba;
	int iAction;
} CUTINFO;

typedef struct CELL_REPLACE
{
	int iDomain,nVTS;
    int VID,CID;
	CString csPath;
} CELL_REPLACE;

typedef struct CELLSTILLINFO
{
	int nVTS;
	__int64 i64IFrame; // Pointer to Nav of selected I frame
    int VID,CID;
} CELLSTILLINFO;



/////////////////////////////////////////////////////////////////////////////
// CVobBlankerApp:
// See VobBlanker.cpp for the implementation of this class
//

class CVobBlankerApp : public CWinApp
{
public:
	CVobBlankerApp();

	bool	m_bInProcess;
	bool	m_bLog;

	BOOL	m_bCheckTitle;
	BOOL	m_bCheckMenu;
	BOOL	m_bCheckIfof;

	BOOL	m_bCheckFolder;
	BOOL	m_bCheckVobPuops;
	BOOL	m_bCheckIfoPuops;

	BOOL	m_bCheckPostPre;
	BOOL	m_bCheckPostPreForced;
	BOOL	m_bCheckElapsed;

	BOOL	m_bCheckFixVobs;

	BOOL	m_bCheckBlankNoB;

	int		m_iIFrameMode;
	int		m_iIMaxStill,m_iIMinStill;

	BOOL	m_bCheckNextMenu,m_bCheckNextTitle;
	BOOL	m_bCheckPrevMenu,m_bCheckPrevTitle;
	BOOL	m_bCheckAttrMenu,m_bCheckAttrTitle;

	uchar	m_buffer[2048*MAXPACKSPERVOBU];
	CString csPath;
	CDialog *m_pLog;
	int		m_nWarnings, m_nErrors;
	bool	m_bFixVobs;
	int		m_nPostPre,m_nActualPostPre;


	FILE *m_Fin, *m_Fout;
	CString m_csFout,m_csFin;


private:
	__int64 m_i64OutputLBA, m_i64TotalLBA, m_i64VOBsize[10];
	int m_nVobout,m_nVobin ;

//	int m_iFirstNavInCell, m_iLastNavInCell, m_iFirstAudioInCell, m_iLastAudioInCell, m_iFirstSubsInCell, m_iLastSubsInCell;
	int m_nAudioStream[8],m_nSubsStream[32];
	int m_nNavsInCell;
	int m_nAudioInCell[8],m_nSubsInCell[32];
	CArray<NAVINFO,NAVINFO> m_ANavinfo;
	CArray<NAVINFO,NAVINFO> m_CellNavinfo;
	CArray<AUDIOINFO,AUDIOINFO> m_AAudioinfo[8];
	CArray<AUDIOINFO,AUDIOINFO> m_CellAudioinfo[8];
	CArray<SUBSINFO,SUBSINFO> m_ASubsinfo[32];
	CArray<SUBSINFO,SUBSINFO> m_CellSubsinfo[32];
	CArray<CELL_LIST,CELL_LIST> m_ACell_list;
	CArray<MENU_CELL_LIST,MENU_CELL_LIST> m_MenuCells[MAX_VTS];

public:
	CArray<CELLSTILLINFO,CELLSTILLINFO> m_ACellStillinfo;
	CArray<CELL_REPLACE,CELL_REPLACE> m_ACell_replace;

	__int64 m_i64GranTotalMax, m_i64GranTotalCurr;
	uchar SimpleVob[2048*5];

////////// Members used to read Titles
	uchar* m_pIFO[MAX_VTS];        
	__int64 m_i64IFOlen[MAX_VTS];
	int m_nIFOs,m_nTotalTitles;
	CString m_csInputPath;
	CString	m_csOutputPath;
	
	CString m_csError;

	bool m_bAngleAll;
	bool m_bILVAll;

	int m_ticsperframe;

	int  m_iFixDuration; 
//Substracts from elapsed time the time stored in m_iFixDuration
#define FIXOFFDURATION 1
//Get duration as new offset, reset elapsed time and change state  to FIXOFFDURATION
#define GETOFFDURATION 2
//Save elapsed time in m_iFixDuration. Do not correct elapsed time.
#define SAVEOFFDURATION 3
//calculate m_iFixDuration, fix elapsed time and change state to FIXOFFSETDURATION
#define CALCULATE_FIXOFFDURATION 4
//calculate ADDOFFDURATION: Related with Replace Title
#define ADDOFFDURATION 5


	DWORD m_dwOffDuration;

	bool	m_bZeroMenu[MAX_VTS];
	bool	m_bZMenu;

////////// Members for info required in VTS ClistView
	CString m_csVTSname[MAX_VTS];
	__int64 m_i64VTSisize[MAX_VTS];
	__int64 m_i64Misize[MAX_VTS];
	__int64 m_i64VTSfsize[MAX_VTS];
	int m_nPGCs[MAX_VTS],m_TT_SRPT;
	int	m_VTS_PTT_SRPT[MAX_VTS];
	int m_VTS_PGCI[MAX_VTS];
	int m_VTS_TMAPTI[MAX_VTS];
	int m_VTS_C_ADT[MAX_VTS];
	int	m_VTS_VOBU_ADMAP[MAX_VTS];
	int m_iVideoAttrBK[MAX_VTS];
	int m_iVideoAttr[MAX_VTS];
	int m_iAudioAttr[MAX_VTS][8];
	int m_iAudioAttrBK[MAX_VTS][8];
	int m_iActionVTS[MAX_VTS];
	int m_nAudio[MAX_VTS];
	int m_iIdAudio[MAX_VTS][8]; // Audio tracks Ids
	int m_iBRAudio[MAX_VTS][8]; // Bitrate 
	int m_nMenuAudio[MAX_VTS];
	int m_iMenuIdAudio[MAX_VTS][8]; // Audio tracks Ids
	int m_iMenuBRAudio[MAX_VTS][8]; // Bitrate 
	bool m_bAngleVTS[MAX_VTS];
	bool m_bILVVTS[MAX_VTS];
	int	 m_nVOBIDs[MAX_VTS];
	int	 m_nMVOBIDs[MAX_VTS];
	int	 m_nVOBIDsInProcess;
	int  m_MenuDiscountSectors[MAX_VTS];
	int  m_TotalDiscountSectors[MAX_VTS];


////////// Pointers to Members for info required in Title ClistView
// All MUST be allocated with new and deallocated with delete in
// NewMemoryVTSTitle and DeleteMemoryVTSTitle

	int * m_nTitle[MAX_VTS];
	bool * m_bEntry[MAX_VTS] ;
	int * m_nTitleInVTS[MAX_VTS] ;
	bool * m_bILVU[MAX_VTS] ;
	int * m_nAngles[MAX_VTS] ;
	bool * m_bCellReUsed[MAX_VTS] ;
	int * m_nCells[MAX_VTS] ;
	int * m_nFirstVID[MAX_VTS] ;
	DWORD * m_dwDuration[MAX_VTS] ;
	DWORD * m_dwDurationOwn[MAX_VTS] ; //Duration of PGC, but only not reused cells.
	__int64 * m_i64Tisize[MAX_VTS] ;
	__int64 * m_i64Rsize[MAX_VTS] ;
	int * m_iAction[MAX_VTS] ;
	int * m_VTS_PGC[MAX_VTS] ;
	int * m_C_PBKT[MAX_VTS] ;
	int * m_C_POST[MAX_VTS] ;
	int * m_PGC_COMM[MAX_VTS] ;
	int * m_iIdTAudio[MAX_VTS][8] ; // Tracks Ids. May be different per Title.
	int * m_iIdTAudioStrip[MAX_VTS][8] ; // Bool to discard stream or not.
	uchar * m_i8CellComm[MAX_VTS] ;
	uchar * m_i8PreComm[MAX_VTS] ;
	uchar * m_i8PostComm[MAX_VTS] ;
	CUTINFO * m_CutInfo[MAX_VTS] ;
	CString * m_csReplace[MAX_VTS] ;
	CString * m_csCellBased[MAX_VTS];
	

////////// Members for info required in Menus

	__int64 m_i64Mfsize[MAX_VTS];
	int m_nLUs[MAX_VTS];
	int m_nMPGCs[MAX_VTS];
// Pointers in IFOs
	int m_VTSM_PGCI[MAX_VTS];
	int m_VTSM_C_ADT[MAX_VTS];
	int	m_VTSM_VOBU_ADMAP[MAX_VTS];

// Pointers in IFOs (LUs)
	int m_VTSM_LU[MAX_VTS][MAX_MLUS];

// Others (LUs)
	int m_nPGCinLU[MAX_VTS][MAX_MLUS];
	char m_szLANG_LU[MAX_VTS][MAX_MLUS][3];
	int m_nIniPGCinLU[MAX_VTS][MAX_MLUS];
	__int64 m_i64MLUisize[MAX_VTS][MAX_MLUS];
	__int64 m_i64MLUfsize[MAX_VTS][MAX_MLUS];

// Pointers in IFOs (MPGCs)
	int * m_MENU_PGC[MAX_VTS];
	int * m_M_C_PBKT[MAX_VTS];
	int * m_M_C_POST[MAX_VTS];
	int * m_M_PGC_COMM[MAX_VTS];

// Others (Menu PGCs)
	int * m_nLU_MPGC[MAX_VTS];
	int * m_iMAction[MAX_VTS];
	__int64 * m_i64MPGCisize[MAX_VTS];
	__int64 * m_i64MPGCfsize[MAX_VTS];
	int * m_nMCells[MAX_VTS];
	int * m_nMFirstVID[MAX_VTS];
	DWORD * m_dwMDuration[MAX_VTS];
	bool * m_bMCellReUsed[MAX_VTS];
	bool * m_b8MCellComm[MAX_VTS];  // true if there is a comand different of LinkTailPGC
	uchar * m_i8MCellComm[MAX_VTS];
	uchar * m_i8MPreComm[MAX_VTS];
	uchar * m_i8MPostComm[MAX_VTS];
	int * m_iReuseLU[MAX_VTS];
	int * m_nButtons[MAX_VTS];
	CString * m_csMCellBased[MAX_VTS];
	
	uchar * m_IFrame;

	bool m_bMaxIframeScan[MAX_VTS];

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVobBlankerApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Main methods
	virtual void MemoryDeleteAll();
	virtual void MemoryDeleteVTSTitle(int nVTS);
	virtual int  MemoryNewVTSTitle(int nVTS, int nPGCs);
	virtual void MemoryDeleteVTSMenu(int nVTS);
	virtual int  MemoryNewVTSMenu(int nVTS, int nPGCs);
	virtual int  ReadIFOs(CString csVideo_TS);
	virtual void GetAudioData();
	virtual void GetMenuAudioData();
	virtual int  GetMenuData();
	virtual void GetMaxIFrameData(int nVTS);
	virtual int  GetButtonsData();
	virtual void GetMenuIniSize();
	virtual void GetMenuEndSize();
	virtual int  ExitInstance();
	virtual void ProcessMenu(int nVTS, CWnd* pDlg);
	virtual void ProcessVob(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoClearAttrib(int nVTS, int iDomain);
	virtual void ProcessIfoVTSPrepare(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoVTSTitle(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoVTSMenu(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoVTSEnd(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoMGR(CWnd* pDlg);
	virtual void TitleKeep(int nVTS,int nT, CWnd* pDlg);
	virtual void TitleCut(int nVTS,int nT, CWnd* pDlg);
	virtual void TitleStrip(int nVTS,int nT, CWnd* pDlg);
	virtual void TitleReplace(int nVTS,int nT, CWnd* pDlg);
	virtual void TitleBlank(int nVTS,int nT, CWnd* pDlg);
	virtual void TitleCellBased(int nVTS,int nT, CWnd* pDlg);
	virtual void TitleCellKeep(int nVTS,int nT, int nCell, CWnd* pDlg);
	virtual void MenuKeep(int nVTS,int nT, CWnd* pDlg);
	virtual void MenuDelpbk(int nVTS,int nT, CWnd* pDlg);
	virtual void MenuCellBased(int nVTS,int nT, CWnd* pDlg);
	virtual void MenuZero(int nVTS,int nT, CWnd* pDlg);
	virtual void MenuBlank(int nVTS,int nT, CWnd* pDlg);
	virtual void MenuReuse(int nVTS,int nT, CWnd* pDlg);
	virtual void MenuStill(int nVTS,int nT,bool bAudio, CWnd* pDlg);
	virtual void MenuCellKeep(int nVTS,int nT, int nCell, CWnd* pDlg);
	virtual void MenuCellStill(int nVTS,int nT, int nCell, bool bAudio, __int64 i64Sector, CWnd* pDlg);
	virtual int  ExtractIFrame(int nVTS,int nT, int nCell, __int64 i64Sector);
	virtual void WritePack(uchar* buffer,int nVTS);
	virtual bool LoadProject(CString FilePath);
	virtual bool SaveProject(CString FilePath);
	virtual void SettingsClear();
	virtual void SettingsSave();

	virtual int  AdjustSectors(CString csPath);


//Aux methods
	virtual void CalculateCutSize(int nVTS, int nT);
	virtual void UpdateVideoAttr(int nVTS);
	virtual void UpdateAudioAttr(int nVTS, int nA);
	virtual void LogEnd();
	virtual void OutputBlankCell(int nVTS,int VobId,int CellId);
	virtual void UpdateProgress( CWnd* pDlg, int nPerc);
	virtual void UpdateProgressCell( CWnd* pDlg, int nPerc);
	virtual int  CellVID(int nVTS,int nT,int nCell); 
	virtual int  CellCID(int nVTS,int nT,int nCell);
	virtual int  CellMVID(int nVTS,int nT,int nCell); 
	virtual int  CellMCID(int nVTS,int nT,int nCell);
	virtual	bool IsReused(int iDomain, int nVTS,int nT,int nCell);
	virtual int ChangePostIntoPre(int iDomain, int nVTS, int nT);
	virtual void MyErrorLog_Box(LPCTSTR text);
	virtual void MyLog(LPCTSTR text);

//methods called from Strip dlg 
	virtual uchar ST_GetAudioStatus(int nVTS, int nT, int nA);
	virtual int   ST_GetAudioDelay(int nVTS, int nT, int nA);

//methods related with TMAPTI
	virtual void ProcessTmapti(int nVTS, int nT, uchar* pIFO);
	virtual int  Findidxlba (int iniidx, int sec, int nVTS, int nT, uchar* pIFO);

//methods called from Preview dlg 
	virtual	__int64 PR_CellIniSector(int m_iDomain,int nVTS, int nT, int nCell);
	virtual __int64 PR_CellSectors(int iDomain, int nVTS, int nT, int nCell);
	virtual __int64 PR_LocateNavSector(int m_iDomain, int nVTS, int iVID, int iCID, __int64 i64sector, bool iNext);
	virtual bool    PR_IsClosedGOP(int nVTS,int nT,int nCell, int iSector);

//methods related with Cells dlg 
	virtual void GetCellInfo(int iDomain, int nVTS,int nT,int nCell, 
			     int * VobId, int * CellId, DWORD * dwDuration,__int64 * i64Size,bool * bReused, uchar * CellCat0, int * nButtons);
	virtual void ExtractCell(int iDomain,int nVTS,int nT, int nCell, CWnd* pDlg);
	virtual int FillCellInfo(int nVTS);
	virtual __int64 CalculateCellBasedSize(int nVTS, int nT);
	virtual __int64 CalculateMenuCellBasedSize(int nVTS, int nT);
	virtual int GetProgram(int iDomain, int nVTS, int nT, int nCell);
	virtual int GetChapter(int nVTS, int nT, int nCell);
	virtual __int64 CalculateStillMenuCellSize(int nVTS,int nT, int nCell, bool bAudio, __int64 i64Sector);


// methods related with pointer adjustments
	virtual void FV_FixVob(int n, CWnd* pDlg);
	virtual void FV_FixNavPack(int n);
	virtual int  FV_FindVobu(int pts,int l,int h);
	virtual unsigned int FV_GetSect(int curvobnum,int jumpvobnum,int skip,unsigned notfound);
	virtual int  FV_FindNextVideo(int cur, int dir);
	virtual __int64 FV_FindAudSect(int aind,int pts0,int pts1);

// Implementation

	//{{AFX_MSG(CVobBlankerApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VOBBLANKER_H__D9C5F094_96B1_4541_8EB0_320F4C91A546__INCLUDED_)
